@echo off
rem ###########################################################################
rem ##                                                                       ##
rem ##  S A M P L E . B A T                                                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Job .......: Sample program using the getpids.exe tool.              ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Copyright (C) 2002  Daniel Scheibli                                  ##
rem ##                                                                       ##
rem ##  This program is free software; you can redistribute it and/or        ##
rem ##  modify it under the terms of the GNU General Public License as       ##
rem ##  published by the Free Software Foundation; either version 2 of       ##
rem ##  the License, or (at your option) any later version.                  ##
rem ##                                                                       ##
rem ##  This program is distributed in the hope that it will be useful,      ##
rem ##  but WITHOUT ANY WARRANTY; without even the implied warranty of       ##
rem ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ##
rem ##  GNU General Public License for more details.                         ##
rem ##                                                                       ##
rem ##  You should have received a copy of the GNU General Public License    ##
rem ##  along with this program; if not, write to the Free Software          ##
rem ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,               ##
rem ##  MA 02111-1307, USA.                                                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Notes .....: When using "getpids.exe -x", one can test for the       ##
rem ##               leading dash of a given PID with "if %XX1PID% LSS 0".   ##
rem ##               To remove the dash try "set /a X*=-1".                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>          ##
rem ##  Date ......: 2003-01-15                                              ##
rem ##  Changes ...: ----- sample.bat 1.00 --------------------------------- ##
rem ##               <none/>                                                 ##
rem ##               ----- sample.bat 0.99.002 ----------------------------- ##
rem ##               2006-09-05 o Update the coding style.                   ##
rem ##               ----- sample.bat 0.99.001 ----------------------------- ##
rem ##               <none/>                                                 ##
rem ##                                                                       ##
rem ###########################################################################



set XX1PID=

for /F "Tokens=3" %%I in ('getpids.exe') do set XX1PID=%%I

if "%XX1PID%" == "" (

	echo.
	echo ===^> ERROR: The current process id could not be retrieved.
	echo.

	goto Exit
)



echo.
echo This batch file is executed under process id %XX1PID%

pause

echo.



:Exit

set XX1PID=




